package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.ext.jl.ast.*;
import polyglot.ext.polyj.types.*;


/**
 * A <code>PolyJCanonicalTypeNode</code> is a type node for a canonical type in Polyj.
 */
public class PolyJCanonicalTypeNode_c extends CanonicalTypeNode_c implements PolyJCanonicalTypeNode
{
    public PolyJCanonicalTypeNode_c( Position pos, Type type) {
        super( pos, type);
    }

    public Node typeCheck(TypeChecker tc) throws SemanticException {
        if (type.isClass()) {
            ClassType ct = type.toClass();
            PolyJTypeSystem ts = (PolyJTypeSystem) type.typeSystem();
            if (!ts.allParamsInst(ct)) {
                throw new SemanticException("Parameterized type " + ct +
                                            " is uninstantiated", position());
            }
        }

        return super.typeCheck(tc);
    }
}
