package polyglot.ext.polyj.types;

import polyglot.types.*;
import java.io.*;

/**
 * A PolyDlg is a delegate for handling any requests
 * from the PolyTypeOps interface.  A ClassType
 * can simply forward these requests to a PolyDlg
 * to avoid having to implement them itself.
 * 
 * This is yet another workaround for the problem of
 * Java not supporting multiple inheritance.  Ideally,
 * the various ClassType subtypes in PolyJ would inherit
 * from both their superclass in the JL types as well
 * as an implementation of PolyDlg.
 */
public interface PolyDlg extends PolyTypeOps, Serializable { }

