package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.jl.types.*;
import polyglot.ext.polyj.ast.*;
import polyglot.ext.polyj.visit.*;

import java.util.*;

/**
 * A WrapDlg is a delegate for handling any requests
 * from the WrappedTypeOps interface. The WrappedClass can 
 * forward requests to a WrapDlg to avoid having to 
 * implement them itself.  
 * 
 * This is yet another workaround for the problem of
 * Java not supporting multiple inheritance.  Ideally,
 * the various ClassType subtypes in PolyJ would inherit
 * from both their superclass in the JL types as well
 * as an implementation of the delegate(s) they need.
 */
interface WrapDlg extends PolyDlg, WrappedTypeOps { 
    int hashCodeImpl();
    boolean isSameImpl(TypeObject t);
}
