package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.ext.polyj.visit.*;

import java.util.*;

class WrappedPolyJParsedClassType_c extends PolyJParsedClassType_c implements WrappedPolyJParsedClassType {
    protected PolyJClassType wrapped;
    protected WrapDlg wDlg;

    WrappedPolyJParsedClassType_c(PolyJParsedClassType r, 
                                  ClassType oldEnclosingType, 
                                  ClassType newEnclosingType, 
                                  PolyJTypeWrapper tw) {
        super(r.typeSystem(), r.typeSystem().defaultClassInitializer(), r.fromSource());
        this.wrapped = r;
        PolyJTypeSystem ts = (PolyJTypeSystem) r.typeSystem();
	
	//hackhack
        //dlg = wDlg = ts.WrapDlg(this, r, oldEnclosingType, newEnclosingType, tw);
	dlg = wDlg = ts.WrapDlg(this, r, oldEnclosingType, newEnclosingType, tw);
    }

    public Kind kind() {
        return wDlg.kind();
    }

    public List methods() {
        return wDlg.methods();
    }

    public List constructors() {
        return wDlg.constructors();
    }

    public MethodInstance originalMethod(MethodInstance mi) {
        return wDlg.originalMethod(mi);
    }

    public ConstructorInstance originalConstructor(ConstructorInstance ci) {
        return wDlg.originalConstructor(ci);
    }

    public List fields() {
        return wDlg.fields();
    }

    public Type superType() {
        return wDlg.superType();
    }

    public List interfaces() {
        return wDlg.interfaces();
    }

    public String fullName() {
        return wDlg.fullName();
    }

    public String name() {
        return wDlg.name();
    }

    public polyglot.types.Package package_() {
        return wDlg.package_();
    }

    public Flags flags() {
        return wDlg.flags();
    }

    public boolean isNested() {
        return wDlg.isNested();
    }

    public boolean isLocal() {
        return wDlg.isLocal();
    }

    public boolean isAnonymous() {
        return wDlg.isAnonymous();
    }

    public ClassType outer() {
        return wDlg.outer();
    }

    public List memberClasses() {
        return wDlg.memberClasses();
    }

    public ClassType memberClassNamed(String name) {
        return wDlg.memberClassNamed(name);
    }

    public String translate(Resolver c) {
        return wDlg.translate(c);
    }
/*
    public boolean isSameImpl(Type t) {
        return wDlg.isSameImpl(t);
    }
  */
    public boolean equalsImpl(TypeObject t) {
        return wDlg.isSameImpl(t);
    }
  
    public int hashCode() {
        return wDlg.hashCodeImpl();
    }

    public String toString() {
        if (outer() != null && ts.equals(outer(),wrappedClass())) {
            return outer().toString();
        } else if (isTopLevel()) {
            return PolyJTranslator.instTypeString(wrappedClass(), args());
        } else if (isMember() || isLocal()) {
            return outer() + "." + name();
        } else {
            return "<anonymous member of " + outer + ">";
            // throw new InternalCompilerError("Unimplemented.");
        }
    }

    public ClassType wrappedClass() {
        return wDlg.wrappedClass();
    }

    public List args() {
        return wDlg.args();
    }

    public PolyJTypeWrapper substitutor() {
        return wDlg.substitutor();
    }
    
}
